exercise_04_35: exercise_04_35.o | .gitignore
	g++ $^ -o $@ 

exercise_04_35.ii: exercise_04_35.cpp
	g++ -E $^ -o $@

exercise_04_35.s: exercise_04_35.ii
	g++ -S $^ -o $@

exercise_04_35.o: exercise_04_35.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04_35" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_04_35 .gitignore debug

test2: exercise_04_35 
	./exercise_04_35 < test2.in > test2.out
	diff test2.out test2.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

test1: exercise_04_35 
	./exercise_04_35 < test1.in > test1.out
	diff test1.out test1.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_35.ii exercise_04_35.s
.SECONDARY: exercise_04_35.ii exercise_04_35.s

dbg: debug/exercise_04_35 

debug/exercise_04_35: debug/exercise_04_35.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_35.o: debug/exercise_04_35.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_35.s: debug/exercise_04_35.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_35.ii: exercise_04_35.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

